using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using ADSLibrary;

namespace PortTest
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ListBox portList;
		private System.Windows.Forms.PictureBox statePicture;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Button nextLineButton;
		private System.Windows.Forms.Button startTest;
		private System.Windows.Forms.Panel portPanel;
	
		private Timer appTimer;
		private bool state;
		private System.Windows.Forms.ListBox portErrors;
		private System.Windows.Forms.RadioButton readOption;
		private System.Windows.Forms.RadioButton writeOption;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label portReadValue;

		string[] GMPorts = {"GPI1:", "GPI2:", "GPI3:", "GPI4:", "GPI5:", "LED1:", "LED2:", "LED3:", "IOA1:", "IOA2:", "IOA3:", "IOA4:", "IOA5:", "IOB1:", "IOB2:", "IOB3:", "IOB4:", "IOB5:", "AIN1:", "AIN2:", "AIN3:", "AIN4:"};

		public Form1()
		{
			InitializeComponent();

			appTimer = new Timer();
			appTimer.Interval = 1000;
			appTimer.Enabled = false;
			appTimer.Tick += new EventHandler(TimerTick);

			state = false;
			
			Image i = new Bitmap(statePicture.Width, statePicture.Height);
			Graphics g = Graphics.FromImage(i);

			g.FillRectangle(new SolidBrush(Color.Transparent), new Rectangle(0, 0, i.Width, i.Height));
			g.FillEllipse(new SolidBrush(Color.Gray), new Rectangle(0, 0, i.Width - 1, i.Height - 1));
			
			statePicture.Image = i;

			g.Dispose();

			foreach(string s in GMPorts)
			{
				portList.Items.Add(s);
			}
		}

		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.portPanel = new System.Windows.Forms.Panel();
			this.portReadValue = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.writeOption = new System.Windows.Forms.RadioButton();
			this.readOption = new System.Windows.Forms.RadioButton();
			this.portErrors = new System.Windows.Forms.ListBox();
			this.startTest = new System.Windows.Forms.Button();
			this.nextLineButton = new System.Windows.Forms.Button();
			this.label8 = new System.Windows.Forms.Label();
			this.statePicture = new System.Windows.Forms.PictureBox();
			this.portList = new System.Windows.Forms.ListBox();
			this.label2 = new System.Windows.Forms.Label();
			// 
			// portPanel
			// 
			this.portPanel.Controls.Add(this.portReadValue);
			this.portPanel.Controls.Add(this.label9);
			this.portPanel.Controls.Add(this.writeOption);
			this.portPanel.Controls.Add(this.readOption);
			this.portPanel.Controls.Add(this.portErrors);
			this.portPanel.Controls.Add(this.startTest);
			this.portPanel.Controls.Add(this.nextLineButton);
			this.portPanel.Controls.Add(this.label8);
			this.portPanel.Controls.Add(this.statePicture);
			this.portPanel.Controls.Add(this.portList);
			this.portPanel.Controls.Add(this.label2);
			this.portPanel.Location = new System.Drawing.Point(8, 8);
			this.portPanel.Size = new System.Drawing.Size(300, 336);
			// 
			// portReadValue
			// 
			this.portReadValue.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold);
			this.portReadValue.Location = new System.Drawing.Point(208, 80);
			this.portReadValue.Size = new System.Drawing.Size(56, 28);
			this.portReadValue.Text = "?";
			this.portReadValue.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// label9
			// 
			this.label9.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, (System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline));
			this.label9.Location = new System.Drawing.Point(208, 56);
			this.label9.Size = new System.Drawing.Size(60, 16);
			this.label9.Text = "Value";
			this.label9.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// writeOption
			// 
			this.writeOption.Checked = true;
			this.writeOption.Location = new System.Drawing.Point(140, 36);
			this.writeOption.Size = new System.Drawing.Size(56, 16);
			this.writeOption.Text = "Write";
			// 
			// readOption
			// 
			this.readOption.Location = new System.Drawing.Point(212, 36);
			this.readOption.Size = new System.Drawing.Size(56, 16);
			this.readOption.Text = "Read";
			// 
			// portErrors
			// 
			this.portErrors.Location = new System.Drawing.Point(132, 160);
			this.portErrors.Size = new System.Drawing.Size(152, 160);
			// 
			// startTest
			// 
			this.startTest.Location = new System.Drawing.Point(212, 124);
			this.startTest.Size = new System.Drawing.Size(72, 32);
			this.startTest.Text = "Start";
			this.startTest.Click += new System.EventHandler(this.startTest_Click);
			// 
			// nextLineButton
			// 
			this.nextLineButton.Location = new System.Drawing.Point(132, 124);
			this.nextLineButton.Size = new System.Drawing.Size(72, 32);
			this.nextLineButton.Text = "Next Line";
			this.nextLineButton.Click += new System.EventHandler(this.nextLineButton_Click);
			// 
			// label8
			// 
			this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, (System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline));
			this.label8.Location = new System.Drawing.Point(136, 56);
			this.label8.Size = new System.Drawing.Size(56, 16);
			this.label8.Text = "State:";
			this.label8.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// statePicture
			// 
			this.statePicture.Location = new System.Drawing.Point(148, 80);
			this.statePicture.Size = new System.Drawing.Size(32, 32);
			// 
			// portList
			// 
			this.portList.Location = new System.Drawing.Point(12, 32);
			this.portList.Size = new System.Drawing.Size(112, 290);
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold);
			this.label2.Location = new System.Drawing.Point(12, 8);
			this.label2.Size = new System.Drawing.Size(280, 20);
			this.label2.Text = "Windows CE Port Functions";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// Form1
			// 
			this.ClientSize = new System.Drawing.Size(314, 351);
			this.Controls.Add(this.portPanel);
			this.Text = "ADS C# PortTest";

		}
		#endregion

		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void startTest_Click(object sender, System.EventArgs e)
		{
			if(appTimer.Enabled)
				startTest.Text = "Start";
			else
			{
				startTest.Text = "Stop";
				
				if(portList.SelectedIndex < 0)
					portList.SelectedIndex = 0;
			}

			appTimer.Enabled = !appTimer.Enabled;
		}
		
		private void TimerTick(object sender, System.EventArgs e)
		{			
			if(writeOption.Checked)
			{
				// display state
				Image i = new Bitmap(statePicture.Width, statePicture.Height);
				Graphics g = Graphics.FromImage(i);

				g.FillRectangle(new SolidBrush(Color.Transparent), new Rectangle(0, 0, i.Width, i.Height));

				if(state)
				{
					g.FillEllipse(new SolidBrush(Color.Red), new Rectangle(0, 0, i.Width - 1, i.Height - 1));
				}
				else
					g.FillEllipse(new SolidBrush(Color.Gray), new Rectangle(0, 0, i.Width - 1, i.Height - 1));			
			
				statePicture.Image = i;
				statePicture.Invalidate();

				g.Dispose();

				state = !state;			

				// toggle the port
				try
				{
					CEPorts.WritePort((string)portList.SelectedItem, state ? (byte)1 : (byte)0);
				}
				catch(Exception ex)
				{
					portList.SelectedIndex += 1;

					portErrors.Items.Add(ex.Message);
				}
			}
			else
			{
				ushort readValue = 0;

				// read the port value
				// Analogs are WORD reads, all else are BYTE reads
				if(((string)portList.SelectedItem).Substring(0, 3) == "AIN")
				{
					try
					{
						readValue = CEPorts.ReadPortWord((string)portList.SelectedItem);
					}
					catch(Exception ex)
					{
						portList.SelectedIndex += 1;

						portErrors.Items.Add(ex.Message);
					}
				}
				else
				{
					try
					{
						readValue = (ushort)CEPorts.ReadPortByte((string)portList.SelectedItem);
					}
					catch(Exception ex)
					{
						portList.SelectedIndex += 1;

						portErrors.Items.Add(ex.Message);
					}
				}

				portReadValue.Text = Convert.ToString(readValue, 16);				
			}
		}

		private void nextLineButton_Click(object sender, System.EventArgs e)
		{
			if(portList.SelectedIndex == portList.Items.Count - 1)
			{
				appTimer.Enabled = false;
				startTest.Text = "Start";
				portList.SelectedIndex = 0;
			}
			else
				portList.SelectedIndex += 1;
		}
	}
}
